{
  Modul Edytor programu iTiczer.
}

Unit Edytor;


 Interface
{=========}

Uses Crt, Dos, Podstawa, Paski, Czytnik;

Type Typ_slowko = Record
          slowko: String [30];
          znaczenie: Array [1..3] Of String [30];
          End;
     Wsk_typ_slowko = ^Typ_slowko;
     Typ_slownik = Array [1..100] Of Wsk_typ_slowko;

Procedure Edytuj(nazwa: String);



 Implementation
{==============}

Procedure Edytuj(nazwa: String);
    Const
        GoraOkna = 8;         {jak wysoko ma sie zaczynac okno}
                              {uzywane, zeby nie zakrywac menu F1,F2...}
    Var
        akt,                  {aktualnie wybrane slowko}
        ile,                  {ilosc slowek w slowniku}
        przerwanie,           {do obslogi zdarzen}
        zmieniony,            {okresla czy dokonano zmian}
        pozycja: Byte;        {aktualna pozycja w danym slowku}
        temp,                 {tymczasowa zmienna tekstkowa}
        opis,                 {opis pliku slownika}
        pozycja_menu: String; {wybrana pozycja z listy menu}
        slownik: Typ_slownik;
        plik: Text;
        klaw: Char;           {klawisz zapytania}
        i, code: Integer;   {pomocnicze, bo Val() potrzebuje 2 integery}


    Procedure Poczatkowe_okno;
       Begin
       Boksik (10, GoraOkna, 70, 21, ' Edycja: '+nazwa+' ', 2, 4, 7, 1);
       TextColor(0);
       NapisXY (20, GoraOkna+3, 'Swko:', 1, 7);
       NapisXY (16, GoraOkna+6, 'Znaczenie1:', 1, 7);
       NapisXY (16, GoraOkna+8, 'Znaczenie2:', 1, 7);
       NapisXY (16, GoraOkna+10, 'Znaczenie3:', 1, 7);
       TextColor(8);
       NapisXY (30, GoraOkna+4, '', 1, 7);
       NapisXY (30, GoraOkna+7, '', 1, 7);
       NapisXY (30, GoraOkna+9, '', 1, 7);
       NapisXY (30, GoraOkna+11, '', 1, 7);
       Rysuj_status (21);
       End;{Poczatkowe_okno}


    Procedure Swierze_okno;
       Begin
       TextColor(4);
       If zmieniony=1 Then
          NapisXY (13, 21, '[zmieniony]', 1, 7);
          {NapisXY (12, 21, Char(15), 1, 7);}
       If zmieniony=0 Then
          NapisXY (13, 21, '', 1, 7);
       temp:=('['+Stringowo(akt)+'/'+Stringowo(ile)+']');
       NapisXY (68-Length(temp), 21, temp, 1, 7);
       Rysuj_pozycje (30, GoraOkna+3, 30, slownik[akt]^.slowko, 0, 7);
       Rysuj_pozycje (30, GoraOkna+6, 30, slownik[akt]^.znaczenie[1], 0, 7);
       Rysuj_pozycje (30, GoraOkna+8, 30, slownik[akt]^.znaczenie[2], 0, 7);
       Rysuj_pozycje (30, GoraOkna+10, 30, slownik[akt]^.znaczenie[3], 0, 7);
       temp:=('');
       End; {Swierze_okno}


    Procedure Wczytaj_slownik;
        Var i: Byte;
        Begin
        {ile:=0;}
        Assign(plik, nazwa+'.dik');
        Reset(plik); {otworz na poczatku}
        Readln(plik, opis);
        While not EOF(plik) do
           Begin
           If ile < 100 Then {nie wczytuj ponad 100}
              Begin
              Inc(ile);
              New(slownik[ile]);
              End;
           Readln(plik, slownik[ile]^.slowko);
           For i:=1 To 3 Do
               Readln(plik, slownik[ile]^.znaczenie[i]);
           End;
        Close(Plik);
        End; {Wczytaj_slownik}


    Procedure Zapisz_slownik;
        Var i, j: Byte;
        Begin
        Assign(plik, nazwa+'.dik');
        Rewrite(plik); {kasuj cala zawartosc i pisz od poczatku}
        Writeln(plik, opis);
        For i:=1 To ile Do
              Begin
              {nie zapisuj pustego slowka}
              If (slownik[i]^.slowko <> '') and
                 (slownik[i]^.znaczenie[1] <> '') Then
                 Begin
                 Writeln(plik, slownik[i]^.slowko);
                 For j:=1 To 3 Do
                     Writeln(plik, slownik[i]^.znaczenie[j]);
                 End;
              End;
        Close(Plik);
        End; {Zapisz_slownik}


    Procedure Nowe_slowko;
        Var i: Byte;
        Begin
        {przydzielenie pamieci}
        New(slownik[akt]);
        {przypisanie wartosci pustych nowym zmiennym}
        slownik[akt]^.slowko:= '';
        For i:=1 To 3 Do
            Slownik[akt]^.znaczenie[i]:= '';
        {zwiekrzenie liczby slowek}
        Inc(ile);
        End; {Nowe_slowko}


    Procedure Usun_slowko;
        Var i: Byte;
        Begin
        If ile > 1 Then
           Begin
           {gdy wybrane ostatnie slowko}
           If akt = ile Then
              Begin
              Dec(akt);
              End {if akt=ile}
           Else {akt<>ile}
              Begin
              For i:=akt To (ile-1) Do
                  Begin
                  slownik[i]^.slowko:= slownik[i+1]^.slowko;
                  slownik[i]^.znaczenie[1]:= slownik[i+1]^.znaczenie[1];
                  slownik[i]^.znaczenie[2]:= slownik[i+1]^.znaczenie[2];
                  slownik[i]^.znaczenie[3]:= slownik[i+1]^.znaczenie[3];
                  End;
              End;
           Dispose(slownik[ile]);
           Dec(ile);
           End {if ile>1}
        Else {ile=1}
           Begin
           slownik[1]^.slowko:='';
           For i:=1 To 3 Do
               slownik[1]^.znaczenie[i]:='';
           End; {ile=1}
        {usuniecie slowka to zmiana, wiec:}
        If zmieniony = 0 Then
           Begin
           zmieniony:=1;
           TextColor(4);
           NapisXY (13, 21, '[zmieniony]', 1, 7);
           {NapisXY (12, 21, Char(15), 1, 7);}
           End;
        End; {Usun_slowko}



    { Koniec podprocedur procedury Edytuj }
    { =================================== }

    Begin
    zmieniony:=0;
    akt:= 1;
    ile:=0;
    przerwanie:=0;
    pozycja:=1;
    Rysuj_menu(10);
    Poczatkowe_okno;
    Wczytaj_slownik;
    If ile = 0 Then
       Nowe_slowko;
    Swierze_okno;
    {glowna petla}
    Repeat
    Case przerwanie Of
    0,99:  Begin {Enter, Tab}
        Case pozycja Of
        1: Begin {dla pozycji pierwszej - .slowko}
           {tak kombinacja, bo nie mozna przekazac <.slowko>, ktore jest
            typu String[30], a wymagane jest String (<temp> jest String)}
           temp:=slownik[akt]^.slowko;
           {przerwij przy pierwszym znaku gdy nie zmieniony}
           If zmieniony=0 Then
              Czytaj (30, GoraOkna+3, 30, temp, przerwanie, 99);
           {gdy juz zmieniony czytaj cale ciagi}
           If zmieniony=1 Then
              Czytaj (30, GoraOkna+3, 30, temp, przerwanie, 3);
           slownik[akt]^.slowko:= temp;
           {zwiekrz pozycje tylko dla Enter i Tab}
           If przerwanie = 0 Then Inc(pozycja);
           End;
        2, 3: {.znaczenie[1] i .znaczenie[2]}
           Begin
           temp:=slownik[akt]^.znaczenie[pozycja-1];
           If zmieniony=0 Then
              Czytaj (30, GoraOkna+6+(pozycja*2-4), 30, temp, przerwanie, 99);
           If zmieniony=1 Then
              Czytaj (30, GoraOkna+6+(pozycja*2-4), 30, temp, przerwanie, 3);
           slownik[akt]^.znaczenie[pozycja-1]:= temp;
           {zwiekrz pozycje tylko dla Enter i Tab}
           If przerwanie = 0 Then Inc(pozycja);
           End;
        4: Begin {.znaczenie[3] (zapetlenie)}
           temp:=slownik[akt]^.znaczenie[3];
           If zmieniony=0 Then
              Czytaj (30, GoraOkna+10, 30, temp, przerwanie, 99);
           If zmieniony=1 Then
              Czytaj (30, GoraOkna+10, 30, temp, przerwanie, 3);
           slownik[akt]^.znaczenie[3]:= temp;
           {zapetl pozycje tylko dla Enter i Tab}
           If przerwanie = 0 Then pozycja:= 1;
           End;
        End; {Case dla Enter, Tab}
        {jesli czytaj zwroci przerwanie 99 to aktualizuj zmieniony}
        If przerwanie=99 Then
           Begin
           zmieniony:=1;
           TextColor(4);
           NapisXY (13, 21, '[zmieniony]', 1, 7);
           {NapisXY (12, 21, Char(15), 1, 7);}
           przerwanie:=0;
           End;
        End; {Enter, Tab}

    1:  Begin {Esc}
        If zmieniony=1 Then
           Begin
           Rysuj_pozycje(68,1,23,'Esc: Wyjcie',1,7);
           Boksik (19, GoraOkna+3, 60, GoraOkna+10, ' Uwaga! ', 2, 15, 1, 1);
           TextColor(LightGray);
           NapisXY (1, GoraOkna+5, 'Nie zapisano zmian.', 3, 99);
           NapisXY (1, GoraOkna+6, 'Czy chcesz teraz zapisa zmiany?', 3, 99);
           Przerwanie:= 1;
           Przyciski_pytania(przerwanie, 58, GoraOkna+8,
                  ' Anuluj ', 6, ' Zapisz ', 6, ' Odrzu ', White, Blue, Red);
           Case przerwanie Of
           1: {anuluj}
              Begin
              Rysuj_pozycje(68,1,23,'Esc: Wyjcie',1,6);
              Poczatkowe_okno;
              Swierze_okno;
              przerwanie:= 0;
              End;
           2: {zapisz}
              Begin
              Zapisz_slownik;
              przerwanie:= 33;
              Rysuj_status(12); {12 zmiany zapisane}
              End;
           3: {odrzuc}
              Begin
              przerwanie:= 33;
              Rysuj_status(3); {3 nie dokonano zmian}
              End;
              End; {case}
           End; {If zmieniony=1}

        If zmieniony=0 Then {jesli niezmieniony}
           Begin
           Rysuj_status(1);
           klaw:= Char(27);
           przerwanie:=33;
           End;
        End; {Esc}

    10: Begin {Page_Up}
        If akt > 1 Then    {pomin gdy na pierwszym slowku}
           Begin
           Dec(akt);       {wybranie wczesniejszego slowka}
           Swierze_okno;
           pozycja:=1;     {pierwsza pozycja}
           End;
        przerwanie:=0;     {przekierowanie do procedur czytania}
        End; {Page_Up}

    11: Begin {Page_Down}
        {nie reaguj gdy aktualne .slowko lub .znaczenie[1] sa puste
         oraz gdy aktualne slowko = 100}
        If (slownik[akt]^.slowko <> '') and
           (slownik[akt]^.znaczenie[1] <> '') and
           (akt < 100) Then
           Begin
           Inc(akt);
           {gdy wybrane slowko bylo rowne ile}
           If (akt-1)=ile Then
              Nowe_slowko;
           Swierze_okno;
           pozycja:=1;
           End;
        przerwanie:=0;     {przekierowanie do procedur czytania}
        End; {Page_Down}


    12: Begin {F1}
        Rysuj_menu(12);
        Rysuj_opcje_menu (pozycja_menu,2,
                         'Zapisz    Ctrl+S',
                         'Zap.jako  Ctrl+A',
                         'Opis',
                         '','');
        Rysuj_menu(10);
        Rysuj_status(21);
        If (pozycja_menu = 'prawo') Or
           (pozycja_menu = 'lewo') Then przerwanie:=13;
        If pozycja_menu = 'brak' Then przerwanie:=0;
        If pozycja_menu = '1' Then przerwanie:=21; {zapisz}
        If pozycja_menu = '2' Then przerwanie:=22; {zapisz jako}
        If pozycja_menu = '3' Then przerwanie:=25; {opis}
        End; {F1}

    13: Begin {F2}
        Rysuj_menu(13);
        Rysuj_opcje_menu (pozycja_menu,19,'Id do    Ctrl+F',
                          'Usu      Ctrl+D','','','');
        Rysuj_menu(10);
        Rysuj_status(21);
        If (pozycja_menu = 'prawo') Or
           (pozycja_menu = 'lewo') Then przerwanie:=12;
        If pozycja_menu = 'brak' Then przerwanie:=0;
        If pozycja_menu = '1' Then przerwanie:=23; {idz do}
        If pozycja_menu = '2' Then przerwanie:=24; {usun}
        End; {F2}

    21: Begin {zapisz}
        Zapisz_slownik;
        zmieniony:=0;
        TextColor(4);
        NapisXY (13, 21, '', 1, 7);
        przerwanie:=0;
        End; {zapisz}

    22: Begin {zapisz jako}
        Rysuj_Status (2);
        Boksik (26, GoraOkna+4, 53, GoraOkna+8,
                    ' Zapisz jako ', Podwojne, White, Blue, Cien);
        TextColor(LightGray);
        NapisXY (32, GoraOkna+6, 'Nazwa:', 1, 99);
        TextColor(DarkGray);
        temp:= nazwa; {zapamietaj poprzednia nazwe}
        Czytaj (39, GoraOkna+6, 8, nazwa, przerwanie, 1);
        {jesli nie nacisnieto Esc}
        If przerwanie = 0 Then
           Begin
           Sukaj_pliku (nazwa, przerwanie);
           {jesli plik juz istnieje}
           If przerwanie=1 Then
              Begin
              Boksik (20, 8, 60, 15, ' Uwaga! ', 2, 15, Red, 1);
              TextColor(LightGray);
              NapisXY (23, 10, 'Plik o podanej nazwie ju istnieje.', 1, 99);
              NapisXY (29, 11, 'Czy chcesz go zastapi?', 1, 99);
              przerwanie:= 1; {1 anuluj, 2 zastp}
              Przyciski_pytania(przerwanie, 52, 13,
                    ' Anuluj ', 8, ' Zastp ', 0, '', White, Red, Blue);
              Case przerwanie of
                  1: {anuluj}
                     Begin
                     nazwa:= temp;  {powrot do starej nazwy}
                     End;
                  2: {zastp}
                     Begin
                     Zapisz_slownik;
                     zmieniony:=0;
                     End;
                  End; {case i}
              End {if przerwanie=1}
           Else {plik o tej nazwie nie istnial}
              Begin
              Zapisz_slownik;
              zmieniony:=0;
              End;
           End
        Else {przerwanie z czytania nazwy pliku <> 0}
           Begin
           nazwa:= temp; {powrot do starej nazwy}
           End;
        Poczatkowe_okno;
        Swierze_okno;
        przerwanie:=0;
        End; {zapisz jako}

    23: Begin {idz do}
        Boksik (28, GoraOkna+4, 52, GoraOkna+8, ' Id do ', 2, 15, 1, 1);
        TextColor(LightGray);
        NapisXY (32, GoraOkna+6, 'Swko nr:', 1, 99);
        temp:='';
        Czytaj (44, GoraOkna+6, 3, temp, przerwanie, 1);
        Val (temp, i, code);  {uaktywnij dane slowko}
        {sprawdza czy podana prawidlowa pozycja}
        If (i >= 1) and (i <= ile) Then
           Begin
           akt:= i;
           pozycja:=1;
           End;
        Poczatkowe_okno;
        Swierze_okno;
        przerwanie:=0;
        End; {idz do}

    24: Begin {usun}
        Boksik (20, 12, 60, 19, ' Uwaga! ', 2, 15, 4, 1);
        TextColor(LightGray);
        NapisXY (23, 14, 'Czy na pewno chcesz usun swko:', 3, 99);
        TextColor(Yellow);
        NapisXY (29, 15, slownik[akt]^.slowko, 3, 99);
        przerwanie:= 1; {1 anuluj, 2 usu}
        Przyciski_pytania(przerwanie, 51, 17,
             ' Anuluj ', 6, ' Usu ', 0, '', White, Red, Blue);
        If przerwanie = 2 Then Usun_slowko;
        Poczatkowe_okno;
        Swierze_okno;
        przerwanie:=0;
        End; {usun}

    25: Begin {opis}
        Boksik (17, GoraOkna+4, 63, GoraOkna+8, ' Opis ', 2, 15, 1, 1);
        TextColor(LightGray);
        temp:= opis;
        Czytaj (20, GoraOkna+6, 40, opis, przerwanie, 0);
        If przerwanie = 0 Then
           zmieniony:= 1
        Else opis:= temp;
        Poczatkowe_okno;
        Swierze_okno;
        przerwanie:=0;
        End; {opis}

    End; {Case}
    Until przerwanie=33;

    {zwolnienie pamieci}
    For akt:= 1 To ile Do
        Dispose(slownik[akt]);
    Szare_tlo_czesc(10, 7, 70, 21);
    Rysuj_menu(0);
    {przeniesienie kursora w prawy dolny rog ekranu}
    NapisXY (80,25, '', 1, 99);
    End;



End.