{
  Modul Lista programu iTiczer.
  Zawiera procedure Lista_plikow odpowiedzialna za wyswietlanie
  listy aktualnych slownikow znajdujacych sie w katalogu .\slowniki\
  Aktualnie zaimplementowane opce:
  * obsluga klawiszy strzalek
  * obsluga klawisz page_up, page_down
  * wyswietlanie okna z opisem slownika znajdujacym
    sie w pierwszym wierszu pliku (bo dos ma nazwy 8+3)
  * wyswietlanie statystyki [numer_slownika/liczba_slownikow]
  * wymienny parametr przerwania
  * usuwanie pliku
}


Unit Lista;


 Interface
{=========}

Uses Crt, Dos, Podstawa, Paski;


Procedure Lista_plikow(var nazwa: String; var przerwanie: Byte);


 Implementation
{==============}
Procedure Lista_plikow(var nazwa: String; var przerwanie: Byte);
{   <nazwa>: Zmiennej tej zostaje nadana nazwa pliku, ktory byl
             ostatnio zaznaczony. Nadanie nastepuje w momencie wyjscia
             z procedury i nastepuje zawsze, niezaleznie od wartosci
             parametru <przerwanie>
    <przerwanie>: 0-Enter; 1-Esc
}
    Var
        DirPliki: SearchRec;
        plik: Text;
        Lista: Array [1..250] Of String[8];
        temp: String;   {tymczasowe zmienna tekstowa}
        i, j,              {liczniki}
        ile,               {liczba plikow w katalogu slowniki}
        skrol,             {dodatkowa zmienna do przewijania ekranu}
        przerwanie_pytania: Byte;  {do obslogi PrzyciskiPytania}
        klaw: Char;


    Function Zassij_opis (nazwa_pliku: string): string;
        {Funkacja zwracajaca opis pliku zawarty w pierwszym wierszu pliku}
        Var opis_pliku: String;
        Begin
        Assign(Plik, nazwa_pliku+'.dik');
        Reset(Plik);
        Readln(Plik, opis_pliku);
        Zassij_opis:= opis_pliku;
        Close(Plik);
        End;
    Procedure Przerwij;
        {wyczyszczenie przed przerwaniem, po tym Exit}
        Begin
        Szare_tlo_czesc (29, 3, 52, 20);
        Szare_tlo_czesc (10, 21, 71, 23);
        Rysuj_status (1);
        End;

    Procedure Usun_plik(nazwa_pliku: String);
        Var rejestry: Registers;  {zestaw rejestrow z modulu Dos}
            fcb : Array[0..37] Of byte;   {Extended FCB}
            nazwa: String[20];    {tymczasowa zmienna do przekazania nazwy}
        Begin
        {nadanie odpowiedniej formy zmiennej <nazwa>}
        nazwa:= nazwa_pliku + '.dik ';
        With rejestry Do
             Begin
            {stworzenie bloku fcb z nazwy}
             ax := $2901;
             ds := seg(nazwa[1]);
             si := ofs(nazwa[1]);
             es := seg(fcb[0]);
             di := ofs(fcb[0]);
             MsDos(rejestry);
               If al <> 0 Then Exit;
             {usuwanie pliku przy urzyciu bloku FCB}
             ah := $13;
             ds := seg(fcb[0]);
             dx := ofs(fcb[0]);
             MsDos(rejestry);
             End;
        End;


    Procedure Wyczyszczenie_ekranu;
        {czysci fragrent ekranu bedacy zawartoscia okna listy}
        Begin
        Window (30, 4, 51, 17);
        TextBackground(7);
        TextColor(0);
        ClrScr;
        Window (31, 4, 49, 17);
        End;

    {poczatek glownej procedury}
    Begin
    {nadanie poczatkowych wartosci}
    For i:=1 To 251 Do Lista[i]:= ('');
    temp:= ('');
    i:=1;
    skrol:=1;
    przerwanie:=0;
    FindFirst('*.dik', AnyFile, DirPliki);
    {przerwanie gdy nieznaleziono zadnych plikow}
    If DosError <> 0 Then
       Begin
       Boksik (20, 9, 60, 15, ' Brak sownikw ', 2, 4, 7, 1);
       NapisXY (25, 12, 'Nie zdefiniowano adnych sownikw.', 3, 99);
       Rysuj_menu(0);
       Rysuj_status(33);
       klaw:=ReadKey;
       klaw:=char(7);
       Szare_tlo_czesc(20,9,60,15);
       Rysuj_status(1);
       przerwanie:=1;
       Exit;
       End;
    {wczytywanie do lista[i] wszystkich plikow}
    While DosError = 0 Do
       Begin
       If i < 252 Then
          Begin
          {wpisanie nazny kolejnych plikow do tablicy}
          lista[i]:= (DirPliki.Name);
          {kasowanie rozszerzenia z nazw plikow}
          Delete (lista[i], Pos('.', lista[i]), 8);
          Inc(i);
          End;
       FindNext(DirPliki);
       End;
    ile:= i-1;
       If ile > 250 Then
          Begin
          Boksik (18, 9, 62, 15, ' Za duo sownikw ', 2, 4, 7, 1);
          NapisXY (25, 11, 'Maksymalna liczba sownikw wynosi 250', 3, 99);
          NapisXY (25, 13, 'Wiecej informacji menu: Pomoc>Bugs''y', 3, 99);
          Rysuj_menu(0);
          Rysuj_status(33);
          klaw:=ReadKey;
          klaw:=char(7);          
          Szare_tlo_czesc(18,9,62,15);
          Rysuj_status(1);
          przerwanie:=1;
          Exit;
          End;
    {glowne okna}
    Boksik (29, 3, 52, 18, ' Lista ', 2, 4, 7, 1);
    Boksik (18, 21, 63, 23, ' Opis ', 2, 8, 7, 1);
    TextColor(4);
    {statystyka na dole okna po prawej}
    temp:= '[1/'+Stringowo(ile)+']';
    NapisXY (52-Length(temp), 18, temp, 1, 7);
    temp:='';
    {przywrocenie okna po NapisXY}
    Window (31, 4 , 49, 17);
    TextColor (0);
    {alfabetyczne sortowanie babelkowe}
    For j:=1 To ile Do
        Begin
        For i:=1 To ile-j Do
            Begin
            If lista[i] > lista[i+1] Then
               Begin
               temp:=lista[i];
               lista[i]:= lista[i+1];
               lista[i+1]:= temp;
               End;
            End;
        End;
    {wypisanie pierwszych 14 pozycji}
    i:=1;
    Repeat
      If i=14 Then
         Begin
         {bez nowej lini w ostatnim wierszu}
         If lista[i] <> '' Then Write (lista[i])
         End
      Else If lista[i] <> '' Then Writeln (lista[i]);
      Inc(i);
    Until i=15;
    {wyswietlenie opisu perwszej pozycji}
    TextColor(1);
    NapisXY (20, 22, Zassij_opis(lista[1]), 1, 7);
    {zaznaczenie pierwszej pozycji na niebiesko}
    Rysuj_pozycje (30, 4, 21, ' '+lista[1], 15, 1);
    Rysuj_status (10);

    {glowna petla obslogi klawiatury}
    i:= 1;
    Repeat
    klaw:= ReadKey;
    Case klaw OF
      Char(0):
        Begin
        klaw:= ReadKey;
        Case klaw Of

        'P': Begin {Dol}
             {zanim trzeba przewijac}
             If skrol < 14 Then
                Begin
                {zabranie podswietlenia poprzedniej pozycji}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],0,7);
                {zapetlenie przy osiagnieciu konca listy}
                If i=ile Then
                   Begin
                   Wyczyszczenie_ekranu;
                   i:=0;
                   skrol:=0;
                   j:=1;
                   Repeat
                     If j=14 Then
                        Begin
                        If lista[j] <> '' Then Write (lista[j])
                        End
                     Else If lista[j] <> '' Then Writeln (lista[j]);
                     Inc(j);
                   Until j=15;
                   End;
                {podswietlenie odpowiedniej pozycji}
                Rysuj_pozycje (30,4+skrol,21,' '+lista[i+1],15,1);
                Inc(skrol);
                End;
             If skrol >= 14 Then
                Begin
                Wyczyszczenie_ekranu;
                {zpetlenie przy osiagnieciu konca listy}
                If i=ile Then
                   Begin
                   i:=0;
                   skrol:=1;
                   j:=1;
                   Repeat
                     If j=14 Then
                        Begin
                        If lista[j] <> '' Then Write (lista[j])
                        End
                     Else If lista[j] <> '' Then Writeln (lista[j]);
                     Inc(j);
                   Until j=15;
                   {podswietlenie pierwszej pozycji}
                   Rysuj_pozycje (30,4,21,' '+lista[1],15,1);
                   End
                Else Begin {gdy skrol, ale bez zapetlenia}
                     {przeskrolowanie wszystkich pozycji do gory}
                     For j:=i-13 To i Do
                         Begin
                         Writeln (lista[j]);
                         End;
                     {podswietlenie nastepnej pozycji na samym dole}
                     Rysuj_pozycje (30,17,21,' '+lista[i+1],15,1);
                     End;
                End;
             Inc(i);
             End;

        'H': Begin {Gora}
             {gdy w srodku okna - tzn. nie na gorze, nie na dole111}
             If skrol > 1 Then
                Begin
                {usuniecie podswietlenia}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],0,7);
                {podswietlenie wyzszej}
                Rysuj_pozycje (30,3+(skrol-1),21,' '+lista[i-1],15,1);
                Dec(skrol);
                End;
             {gdy juz na samej goze okna}
             If skrol = 1 Then
                Begin
                Wyczyszczenie_ekranu;
                {zapetlenie na poczatku listy}
                If i=1 Then
                   Begin
                   i:=ile;
                   {gdy pozycji mniej niz w jednym oknie}
                   If ile < 14 Then
                      Begin
                      skrol:= ile;
                      For j:=1 To i Do
                          Begin
                          Writeln (lista[j]);
                          End;
                      Rysuj_pozycje (30,3+ile, 21,' '+lista[i],15,1);
                      End
                   Else {pozycji wiecej niz w jednym oknie}
                      Begin
                      skrol:=14;
                      For j:=i-14 To i Do
                          Begin
                          If j < i Then
                             Writeln (lista[j])
                          Else
                             Write (lista[j]);
                          End;
                      Rysuj_pozycje (30,17,21,' '+lista[i],15,1);
                      End;
                   Inc(i);
                   End
                Else {gdy nie na poczatku listy}
                   Begin
                   j:=i;
                   Window (31, 5 , 49, 17);
                   Repeat
                     If j=i+12 Then
                        Begin
                        If lista[j] <> '' Then Write (lista[j])
                        End
                     Else If lista[j] <> '' Then Writeln (lista[j]);
                     Inc(j);
                   Until j=i+13;
                   Rysuj_pozycje (30,4,21,' '+lista[i-1],15,1);
                   End;
                End;
             Dec(i);
             End;

        'Q': Begin {Page_down}
             {gdy lista krotrza niz okno}
             If ile < 15 Then
                Begin
                {usuniecie podswietlenia}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],0,7);
                i:=ile;
                skrol:=ile;
                {podswietlenie pierwszej}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
                End
             Else {gdy lista dlozsza niz okno}
                Begin
                {gdy nie trzeba przewijac listy}
                If i=(ile+skrol-14) Then
                   Begin
                   Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],0,7);
                   i:=ile;
                   skrol:=14;
                   Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
                   End
                {gdy trzeba przewijac}
                Else
                   Begin
                   Wyczyszczenie_ekranu;
                   {gdy skrol zmienia polozenie}
                   If i > (ile+skrol-14-13) Then
                      Begin
                      i:=ile;
                      skrol:=14;
                      End
                   {gdy skrol pozostaje w miejscu}
                   Else
                      i:=i+13;
                   For j:=i-(skrol-1) To i-(skrol-1)+13 Do
                       Begin
                       If j=i-(skrol-1)+13 Then
                          Begin
                          If lista[j] <> '' Then Write (lista[j])
                          End
                       Else If lista[j] <> '' Then Writeln (lista[j]);
                       End;
                   Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
                   End; {If Else - gdy trzeba przewijac}
                End {If Else - gdy lista dlozsza niz okno}
             End; {Page_down}

        'I': Begin {Page_up}
             {gdy nie trzeba przewijac listy}
             If i=skrol Then
                Begin
                {usuniecie podswietlenia}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],0,7);
                i:=1;
                skrol:=1;
                {podswietlenie pierwszej}
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
                End
             {gdy liste trzeba przewinac}
             Else
                Begin
                Wyczyszczenie_ekranu;
                {gdy skrol musi zmienic polozenie}
                If i-skrol < 13 Then
                   Begin
                   i:=1;
                   skrol:=1;
                   End
                Else  {gdy skrol zostaje na miejscu}
                   i:=i-13;
                {wypisanie od gory tak zeby trafic w odpowiedni skrol}
                For j:=i-(skrol-1) To i-(skrol-1)+13 Do
                    Begin
                    If j=i-(skrol-1)+13 Then
                       Begin
                       If lista[j] <> '' Then Write (lista[j])
                       End
                    Else If lista[j] <> '' Then Writeln (lista[j]);
                    End;
                Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
                End; {If Else - gdy liste trzeba przewijac}
             End; {Page_Up}

        'S': Begin {Del}
             {rysowania okna}
             Boksik (20, 10, 60, 17, ' Uwaga! ', 2, 15, 4, 1);
             TextColor(8); {szary}
             NapisXY (29, 18, 'ͼ',1 ,0);
             temp:= '['+Stringowo(i)+'/'+Stringowo(ile)+']';
             NapisXY (52-Length(temp), 18, temp, 1, 0);
             TextColor(LightGray);
             NapisXY (23, 12, 'Czy napewno chcesz usun slownik:', 3, 4);
             TextColor(Yellow);
             NapisXY (29, 13, lista[i], 3, 4);
             {obsloga klawiatory}
             przerwanie_pytania:= 1; {1 Anuluj, 2 Usu}
             Przyciski_pytania(przerwanie_pytania, 52, 15,
                  ' Anuluj ', 8, ' Usu ', 0, '', White, Red, Blue);
             Case przerwanie_pytania Of
                1: {anuluj}
                   Begin
                   klaw:= Char(7);
                   {zmazanie okna}
                   Szare_tlo_czesc(20, 10, 60, 17);
                   Boksik (29, 3, 52, 18, ' Lista ', 2, 4, 7, 1);
                   End;
                2: {usu}
                   Begin
                   klaw:= Char(7);
                   temp:=lista[i];
                   Usun_plik(temp);
                   {jesli to byl ostatni slownik to przerwij}
                   If ile=1 Then
                      Begin
                      przerwanie:=1;
                      klaw:=Char(13);
                      End
                   Else {nie ostatni slownik}
                      Begin
                      {jesli wybrana byla ostatnia pozycja}
                      If i=ile Then
                         Begin
                         Dec(i);
                         {gdy mniej pozycji niz miesci sie w oknie}
                         If ile < 15 Then
                            Dec(skrol);
                         End
                      {wybrana nie ostatnia pozycja}
                      Else
                         Begin
                         For j:=i To (ile-1) Do
                             lista[j]:=lista[j+1];
                         {gdy nie ostatnie ale lista przewinieta na sam dol
                          tak, ze widzac ostatnia, oczywiscie poza sytuacja
                          gdy wybrany pierwszy plik}
                         If ((i-(skrol-1)+13) = ile) and (i > 1)
                                                  and (ile > 14) Then
                            Begin
                            Dec(i);
                            End;
                         End;
                      lista[ile]:= '';
                      Dec(ile);
                      End; {nie ostatni slownik}
                   End;

             End; {Case}
             {odswierzenie listy}
             {zmazanie okna}
             Szare_tlo_czesc(20, 10, 60, 17);
             Boksik (29, 3, 52, 18, ' Lista ', 2, 4, 7, 1);
             Wyczyszczenie_ekranu;
             {wypisanie od gory tak zeby trafic w odpowiedni skrol}
             For j:=i-(skrol-1) To i-(skrol-1)+13 Do
                 Begin
                 If j=i-(skrol-1)+13 Then
                    Begin
                    If lista[j] <> '' Then Write (lista[j])
                    End
                 Else
                    Begin
                    If lista[j] <> '' Then Writeln (lista[j])
                    End;
                 End;
             Rysuj_pozycje (30,3+(skrol),21,' '+lista[i],15,1);
             End; {Del}


        End; {Case dla Char(0)}
        If przerwanie = 0 Then
           Begin
           TextColor(4);
           temp:= '['+Stringowo(i)+'/'+Stringowo(ile)+']';
           NapisXY (42, 18, '',1 ,7);
           NapisXY (52-Length(temp), 18, temp, 1, 7);
           Rysuj_pozycje (20, 22, 40, Zassij_opis(lista[i]), 1, 7);
           Rysuj_status(10);
           End;
        End; {Char(0)}

      Char(27): {Esc}
        Begin
        przerwanie:=1;
        klaw:= Char(13);
        End; {Esc}
    End; {Perwsze wywolanie Case}
    Until klaw = Char(13); {Enter}

    If przerwanie = 0 Then
       nazwa:= (lista[i]);
    Szare_tlo_czesc (29, 3, 52, 20);
    Szare_tlo_czesc (10, 21, 71, 23);
    Rysuj_status (1);
    End;

End.