{
  Modul Nauka programu iTiczer.
}

Unit Nauka;


 Interface
{=========}

Uses Crt, Dos, Podstawa, Paski, Czytnik;

Type Typ_slowko = Record
          slowko: String [30];
          znaczenie: Array [1..3] Of String [30];
          nauczone: Byte;
          End;
     Wsk_typ_slowko = ^Typ_slowko;
     Typ_slownik = Array [1..100] Of Wsk_typ_slowko;

Procedure Nauczka(nazwa: String);


 Implementation
{==============}

Procedure Nauczka(nazwa: String);
    Var
        akt,                  {aktualnie wybrane slowko}
        ile,                  {ilosc slowek w slowniku}
        przerwanie,           {do obslogi zdarzen}
        ile_nauczonych: Byte; {liczba nauczonych slowek}
        temp,                 {tymczasowa zmienna tekstkowa}
        opis,                 {opis pliku slownika}
        pozycja_menu: String; {wybrana pozycja z listy menu}
        slownik: Typ_slownik;
        plik: Text;
        klaw: Char;           {klawisz zapytania}


    Procedure Pytanie;
       Begin
       Rysuj_status(31);
       TextColor(0);
       NapisXY (02,1, 'Liczba swek: '+Stringowo(ile)+'  ', 1, 6);
       NapisXY (25,1, 'Nauczonych: '+Stringowo(ile_nauczonych)+'  ', 1, 6);
       NapisXY (45,1, 'Pozostao: '+Stringowo(ile-ile_nauczonych)+'  ', 1, 6);
       Boksik (10, 7, 70, 21, ' Sownik: '+nazwa+' ', Podwojne, Brown, LightGray, Cien);
       TextColor(Black);
       NapisXY (15, 11, 'Co znaczy swko '+slownik[akt]^.slowko+'?', 3, 7);
       NapisXY (18, 15, 'Odpowiedz:', 1, 7);
       TextColor(DarkGray);
       NapisXY (29, 16, '', 1, 7);
       temp:='';
       Czytaj (29, 15, 30, temp, przerwanie, 0); {wszystkie znaki}
       End; {Pytanie}


    Procedure Wczytaj_slownik;
        Var i: Byte;
        Begin
        {ile:=0;}
        Assign(plik, nazwa+'.dik');
        Reset(plik); {otworz na poczatku}
        Readln(plik, opis);
        While not EOF(plik) do
           Begin
           If ile < 100 Then {nie wczytuj ponad 100}
              Begin
              Inc(ile);
              New(slownik[ile]);
              End;
           Readln(plik, slownik[ile]^.slowko);
           For i:=1 To 3 Do
               Readln(plik, slownik[ile]^.znaczenie[i]);
           slownik[ile]^.nauczone:= 0; {wszystkie oznacz jako nienauczone}
           End;
        Close(Plik);
        End; {Wczytaj_slownik}



    Begin
    akt:= 1;
    ile:=0;
    ile_nauczonych:=0;
    przerwanie:=0;
    Wczytaj_slownik;
    If ile=0 Then
       przerwanie:=100  {slownik nie posiada zadnych slowek}
    Else
       Begin
       Randomize;       {jesli posiada uruchom generator liczb losowych}
       Rysuj_menu(40);     {samo Esc: Wyjscie}
       End;
    {glowna petla}
    Repeat
    Case przerwanie Of

    0:  Begin {Enter, Tab}
        Repeat
        akt:= Random(ile+1);
        If akt=0 Then akt:=1; {bo Random() generuje od zera}
        Until slownik[akt]^.nauczone = 0;
        Pytanie;
        If (przerwanie=0) Then
           Begin
           If (temp <> '') and
              ((temp = slownik[akt]^.znaczenie[1]) or
               (temp = slownik[akt]^.znaczenie[2]) or
               (temp = slownik[akt]^.znaczenie[3])) Then
              przerwanie:=30 {poprawna odpowiedz}
           Else
              przerwanie:=31; {niepoprawna odpowiedz}
           End;

        End; {Enter, Tab}

    1:  Begin {Esc}
        Rysuj_pozycje(68,1,23,'Esc: Wyjcie', Blue, LightGray);
        Boksik (19, 9, 60, 16, ' Uwaga! ', Podwojne, White, Blue, Cien);
        TextColor(LightGray);
        NapisXY (1, 12, 'Czy napewno chcesz przerwa nauk?', Srodek, StaryKolor);
        przerwanie:= 1; {1 Anuluj, 2 Przerwij}
        Przyciski_pytania(przerwanie, 52, 14,
                  ' Anuluj ', 8, ' Przerwij ', 0, '', White, Blue, Red);
        Case przerwanie Of
             1: {anuluj}
                przerwanie:= 0; {nieprzerywaj}
             2: {przerwij}
                przerwanie:= 33; {przerwij}
             End; {case}
        Rysuj_pozycje(68,1,23,'Esc: Wyjcie',1,6);
        End; {Esc}

    30: Begin {poprawna odpowiedz}               {7}
        Boksik (17, 9, 63, 17, ' Dobrze ', 2, 15, 1, 1);
        TextColor(LightGray);
        NapisXY (20,11,'Tak, '+slownik[akt]^.slowko+' oznacza:',3,1);
        TextColor(Yellow);
        NapisXY (16, 13, slownik[akt]^.znaczenie[1], 3, 1);
        NapisXY (16, 14, slownik[akt]^.znaczenie[2], 3, 1);
        NapisXY (16, 15, slownik[akt]^.znaczenie[3], 3, 1);
        slownik[akt]^.nauczone:= 1;
        Inc(ile_nauczonych);
        Rysuj_status(33);
        klaw:=ReadKey;
        klaw:=char(7);
        If ile_nauczonych = ile Then
           przerwanie:=32
        Else
           przerwanie:=0;
        End; {poprawna odpowiedz}


    31: Begin {nie poprawna odpowiedz}
        Boksik (15, 9, 65, 17, ' le ', 2, 15, 1, 1);
        TextColor(LightGray);
        NapisXY (20,11,
                'Niestety, '+slownik[akt]^.slowko+' oznacza:',3,1);
        TextColor(Yellow);
        NapisXY (16, 13, slownik[akt]^.znaczenie[1], 3, 1);
        NapisXY (16, 14, slownik[akt]^.znaczenie[2], 3, 1);
        NapisXY (16, 15, slownik[akt]^.znaczenie[3], 3, 1);
        Rysuj_status(33);
        klaw:=ReadKey;
        klaw:=char(7);
        przerwanie:=0;
        End; {nie poprawna odpowiedz}

    32: Begin {wszystkie nauczone}
        TextColor(0);
        NapisXY (25,1, 'Nauczonych: '+Stringowo(ile)+'  ', 1, 6);
        NapisXY (45,1, 'Pozostao: 0  ', 1, 6);
        Boksik (17, 9, 63, 17, ' Wszystkie nauczone ', 2, 15, 1, 1);
        NapisXY (20,12,'Gratuluje! Udao Ci si opanowa',3,1);
        NapisXY (16,14,'wszystkie swka ze sownika '+nazwa+'.', 3, 1);
        Rysuj_status(33);
        klaw:=ReadKey;
        klaw:=char(7);
        przerwanie:=33;
        End; {wszystkie nauczone}


    100:Begin {brak slowek w pliku slownika}
        Boksik (17, 9, 63, 15, ' Brak swek ', 2, 4, 7, 1);
        NapisXY (25, 12, 'Ten sownik nie posiada adnych swek.', 3, 99);
        Rysuj_menu(0);
        Rysuj_status(33);
        klaw:=ReadKey;
        klaw:=char(7);
        przerwanie:=33;
        End; {brak slowek w pliku slownika}

    End; {Case}
    Until przerwanie=33;

    {zwolnienie pamieci}
    If ile > 0 Then {nie wykonuj gdy nie bylo slowek w slowniku}
       Begin
       For akt:= 1 To ile Do
           Dispose(slownik[akt]);
       End;
    Szare_tlo_czesc(10, 7, 70, 21);
    Rysuj_menu(0);
    Rysuj_status(1);
    End;



End.