{
  Program do nauki jezykow obcych z obsluga polskich i niemieckich znakow.
  Autor: Tomasz Daek
  Ostatnia aktualizacja: 24.09.2006
  Wersja: 1.1.0
}

Program iTiczer;

Uses Crt, Dos, Podstawa, Paski, Czytnik, Lista, Edytor, Nauka, Pomoc;


Var i: integer;
    nazwa_pliku, opis_pliku, wybrana_pozycja : String;
    Klawisz: Char;



Procedure Stwoz_plik (nazwa: String; var przerwanie: Byte);
{   Ostatni etap tworzenia nowego slownika.
    Wyswietla okno dodania opisu pliku poczym
    tworzy nowy plik na dysku twardym.
}
    Var plik: Text;
    Begin
    Boksik (10, 8, 70, 12, ' Opis ', Podwojne, Brown, LightGray, Cien);
    TextColor(DarkGray);
    NapisXY (20, 11, '',
             WlasneOkno, StaryKolor);
    Rysuj_status (6);
    Czytaj (20, 10, 40, opis_pliku, przerwanie, 0);
    If przerwanie = 0 Then
       Begin
       Assign(Plik, nazwa+'.dik');
       Rewrite(Plik);
       Writeln (plik, opis_pliku);
       Close(Plik);
       End;
    Szare_tlo_czesc(10,8,70,12);
    End;


Procedure Nowy_plik (var Nazwa: String);
{   Zdazenia przy wywolaniu opcji 'Nowy      Ctrl+N'.
    Tworzy okno tworzenia nowego pliku.
}
    Var jest : Byte;
        pytanie: char;
        przerwanie: Byte; {do przechwytywania wywolan procedury Czytaj}
    Begin
    Rysuj_Status (2);
    Boksik (26, 8, 53, 12, ' Nowy sownik ', Podwojne, Brown, LightGray, Cien);
    TextColor(Black);
    NapisXY (32, 10, 'Nazwa:', WlasneOkno, StaryKolor);
    TextColor(DarkGray);
    NapisXY (39, 11, '', WlasneOkno, StaryKolor);
    Czytaj (39, 10, 8, nazwa, przerwanie, 1);
    If nazwa = '' Then przerwanie:= 1; {tak jak anuluj}
    If przerwanie = 0 Then
      Begin
      Sukaj_pliku (nazwa, jest);
      If jest=1 Then {plik juz istnieje}
         Begin
         Boksik (20, 8, 60, 15, ' Uwaga! ', Podwojne, White, Red, Cien);
         TextColor(LightGray);
         NapisXY (23, 10, 'Plik o podanej nazwie ju istnieje.', WlasneOkno, StaryKolor);
         NapisXY (29, 11, 'Czy chcesz go zastapi?', WlasneOkno, StaryKolor);
         przerwanie:=1;
         Przyciski_pytania(przerwanie, 52, 13,
              ' Anuluj ', 8, ' Zastp ', 0, '', White, Red, Blue);
         If przerwanie = 2 Then
            jest:=0; {plik nie istniej}
         Szare_tlo_czesc(20, 8, 60, 15);
         Rysuj_Status(9); {anulowana}
         End;
      If jest = 0 Then {plik nie istnieje}
         Begin
         Szare_tlo_czesc(25, 8, 55, 12);
         Stwoz_plik(nazwa, przerwanie);
         If przerwanie = 0 Then
            Rysuj_Status (5) {plik utworzony}
         Else Rysuj_status(9) ; {anulowano}
         End;
      End {if przerwanie=0}

      Else {przerwanie podawania nazwy pliku}
           Begin
           Szare_tlo_czesc(25,8,54,12);
           Rysuj_status(9); {anulowano}
           End;
    End; {Procedure Nowy_plik (var Nazwa: String);}


Procedure Otworz_plik;
{   Zdarzenia przy wywolaniu opcji 'Otwrz    Ctrl+O'.
}
    Var przerwanie: Byte;
    Begin
    Lista_plikow(nazwa_pliku, przerwanie);
    If przerwanie = 0 Then
       Edytuj(nazwa_pliku);
    End;

Procedure Ucz_sie;
{   Zdarzenia przy wywolaniu opcji 'Ucz si!  Ctrl+U'.
}
    Var przerwanie: Byte;
    Begin
    Lista_plikow(nazwa_pliku, przerwanie);
    If przerwanie = 0 Then
       Nauczka(nazwa_pliku);
    End;

Procedure Koniec;
{   Ostatnia procedura wyjscia z prgramu.
    Przywrocenie standardowych kolorow wyswietlania oraz
    ostateczne wyjscie z programu.
}
    Begin
    Zero_tlo;
    Boksik (30, 10, 53, 14, ' Koniec ', 2, 8, 7, 3);
    NapisXY (36, 12, 'iTiczer 1.1.0', 1, 99 );
    Window (1,1,80,25);
    TextColor(0);
    GotoXY (1,16);
    ChDir('..');
    {Repeat Until KeyPressed;}
    Halt;
    End;

Procedure Wyjscie;
{   Zdarzenia przy wywolaniu opcji 'Esc: Wyjscie'
}
    Var decyzja: Byte; {1 anuluj, 2 koniec}
    Begin
    Rysuj_menu(4);
    Boksik (20, 9, 60, 15, ' Wyjcie ', Podwojne, Red, LightGray, Cien);
    TextColor(black);
    NapisXY (28, 11, 'Czy napewno chcesz wyj?', 1, 99);
    decyzja:=1;
    Przyciski_pytania(decyzja, 52, 13,
       ' Anuluj ', 8, ' Wyjd ', 0, '', White, LightGray, Red);
    If decyzja = 2 Then Koniec;
    Rysuj_menu(0);
    Szare_tlo_czesc(20,9,60,15);
    Rysuj_status(1);
    End;


Procedure Menu_F1;
{   Zdarzenia przy rozwinieciu menu 'F1 Sowniki'.
}
    Begin
    Rysuj_menu(1);
    Rysuj_opcje_menu (wybrana_pozycja, 2,
                'Nowy      Ctrl+N', 'Otwrz    Ctrl+O','','','');
    Rysuj_menu(0);
    If wybrana_pozycja = '1' Then
       Nowy_plik(nazwa_pliku);
    If wybrana_pozycja = '2' Then
       Otworz_plik;
    If wybrana_pozycja = 'prawo'Then wybrana_pozycja:= 'F2';
    If wybrana_pozycja = 'lewo' Then wybrana_pozycja:= 'F3';

    End;

Procedure Menu_F2;
{   Zdarzenia przy rozwinieciu menu 'F2 Nauka'.
}
    Begin;
    Rysuj_menu(2);
    Rysuj_opcje_menu (wybrana_pozycja, 19, 'Ucz si!  Ctrl+U',
                      '','', '','');
    Rysuj_menu(0);
    If wybrana_pozycja = '1' Then Ucz_sie;
    If wybrana_pozycja = 'prawo'Then wybrana_pozycja:= 'F3';
    If wybrana_pozycja = 'lewo' Then wybrana_pozycja:= 'F1';
    End;

Procedure Menu_F3;
{   Zdarzenia przy rozwinieciu menu 'F3 Pomoc'.
}
    Begin
    Rysuj_menu(3);
    Rysuj_opcje_menu (wybrana_pozycja, 33,
                      'Pomoc', 'Bugs''y','Informacje o...','','');
    Rysuj_menu(0);
    If wybrana_pozycja = '1' Then Okno_pomocy;
    If wybrana_pozycja = '2' Then Okno_bagi;
    If wybrana_pozycja = '3' Then Okno_informacji;
    If wybrana_pozycja = 'prawo'Then wybrana_pozycja:= 'F1';
    If wybrana_pozycja = 'lewo' Then wybrana_pozycja:= 'F2';
    End;


Procedure Twoz_katalog;
{   Urzuchamiana raz, na samym poczatku dzialania programu.
    Sprawdza czy katalog Slowniki w bierzacym katalogu istnieje.
    Jesli nie istenieje tworzy go.
}
    Begin
    {proba wejscia do katalogu .\Slowniki }
    {$I-}
    ChDir('slowniki');
    {$I+}
    If IOResult <> 0 Then
       Begin
       {gdy proba nie udana tworzy nawy katalog .\Slowniki }
       {$I-}
       MkDir('slowniki');
       ChDir('slowniki');
       {$I+}
       If IOResult <> 0 Then
          Begin
          {gdy stworzenie nowego katalogu nie powiedzie sie,
           wyswietla informacje o bledzie i konczy dzialanie programu}
          Writeln('Nie mozna utworzyc katalogu .\Slowniki!');
          Halt;
          End
       Else Begin End;
       End;
    End;


{Koniec Procedur}
{===============}

Begin
Twoz_katalog;
DirectVideo:= True;
CheckSnow:= False;
Szare_tlo;
Rysuj_menu(0);
Rysuj_status (1);

{ glowna petla programu }
Repeat
{<wybrana_pozycja> przybiera wartosci 'Fx', przy nacisnieciu klawiszy
 strzalka w lewo lub prawo, podczas gdy ktores z menu jest rozwiniete}
     If wybrana_pozycja = 'F1' Then Menu_F1;
     If wybrana_pozycja = 'F2' Then Menu_F2;
     If wybrana_pozycja = 'F3' Then Menu_F3;
     If wybrana_pozycja = 'brak' Then Rysuj_status(1);

{sprawdzenie czy <wybrana_pozycja> nie zaczyna sie na F}
     If Copy(wybrana_pozycja, 1, 1) <> 'F' Then
        {obsluga wywolan z klawiatury}
        Begin
            klawisz:= ReadKey;
               Case klawisz of
               Char(0): Begin
                        klawisz:= ReadKey;
                           Case klawisz of
                           ';': Menu_F1; {F1}
                           '<': Menu_F2; {F2}
                           '=': Menu_F3; {F3}
                           End;
                        End;
               Char(14): Nowy_plik(nazwa_pliku); {Ctrl+N}
               Char(15): Otworz_plik; {Ctrl+O}
               Char(21): Ucz_sie; {Ctrl+U}
               Char(27): Wyjscie; {Esc}
               End;
        End;
Until Klawisz = Char(12);
End.