{
  Modul podstawowy programu iTiczer.
  Zawiera procedury przyspieszajace wyswietlanie roznego
  rodzaju napisow. Pozwala zachowac jednolity wyglad programu.
}

Unit Podstawa;


 Interface
{=========}

Uses Crt, Dos;

Const
{dla Boksiku}
Pojedyncze = 1;
Podwojne   = 2;
Cien       = 1;
CienBrak   = 0;

{dla NapisXY}
BezOkna    = 0;
WlasneOkno = 1;
Srodek     = 3;
StaryKolor = 99;


Function Stringowo (wartosc: Byte): String ;
Procedure NapisXY (x, y: Byte;
                   napis: String;
                   czy, {BezOkna, WlasneOkno, Srodek}
                   kolor_tla: Byte); {normalne kolory, StaryKolor}
Procedure Rysuj_pozycje (x, y, l: Byte; napis: String;
                        kolor_napisu, kolor_tla: Byte);
Procedure Boksik (x1, y1, x2, y2: Byte;
                  Tytul: String;
                  styl: Byte; {Pojedyncze, Podwojne}
                  kolor_napisu, kolor_tla,
                  cien: Byte); {Cien, CienBrak}
Procedure Szare_tlo;
Procedure Szare_tlo_czesc (x1, y1, x2, y2: Byte);
Procedure Zero_tlo;
Procedure Sukaj_pliku (var nazwa: String; var jest: Byte );


 Implementation
{==============}

Function Stringowo (wartosc: Byte): String ;
{   Przyspiesza zamiane <wartosci> liczbowej na <lancuch>
}
         Var lancuch: String;
         Begin
         Str (wartosc, lancuch);
         Stringowo:= lancuch;
         End;

Procedure NapisXY (x, y: Byte; napis: String; czy, kolor_tla: Byte);
{   Wyswietla <napis> w odpowiednich wspolzednych <x> i <y>
    opcje zmienne <czy>:
       0-nie zmienia okna; 1-zmienia definicje okna
       3-pisze na srodku ekranu tzn. wybierasz tylko wiersz
    opcje zmiennej <kolor_tla>:
       99-nie zmienia koloru
       inne-jaka liczba, taki kolor
}
          Var start: Byte;    {okresla gdzie ma zaczas pisac}
          Begin                  {by napis byl na srodku}
          If kolor_tla <> 99 Then
             TextBackGround (kolor_tla);
          If czy=0 Then
             GotoXY (x, y);
          If czy=1 Then
             Window (x, y, x + Length(napis), y);
          If czy=3 Then
             Begin
             start:= 40-(Length(napis) div 2);
             Window (start, y, start+Length(napis), y);
             End;
          Write (napis);
          End;

Procedure Rysuj_pozycje (x, y, l: Byte; napis: String;
                        kolor_napisu, kolor_tla: Byte);
{   Procedura rozszezajaca procedure NapisXY.
    Dzieki niej tworzony jest gotowa pozycja roznych list.
    Wykorzystywana w procedurach rysowania pozycji menu
    oraz przy rysowaniu listy dostepnych slownikow.
    <x> i <y> - wspolzedne pozycji.
    <l> - dlugosc pozycji (niezaleznie od tego jak dlugi jest napis
          w danej pozycji - ulatwia podswietlanie wybranych pozycji).
    <napis> - tekst wyswietlany w danej pozycji.
    <kolor_napisu> i <kolor_tla> - znaczenie jak w nazwie.
}
          Begin
          Window (x, y, x+l, y);
          TextColor (kolor_napisu);
          TextBackGround (kolor_tla);
          ClrEol;
          NapisXY (x, y, napis, 1, kolor_tla);
          End;



Procedure Boksik (x1, y1, x2, y2: Byte; Tytul: String; styl: Byte;
                  kolor_napisu, kolor_tla, cien: Byte);
{   Rysuje okienko o wymiarach <x1> <y2> <x2> <y2>
    Na pasku tytuowym okna wypisuje <tytul>
    Opce zmiennej <styl>:
       1-linie pojedyncze; inne-linie podwojne
    Zmienne <kolor_napisu> i <kolor_tla> tak jak ich nazwa
    Opce zmiennej <cien>:
       1 - rysuje  cien okna; inne - nie rysuje cienia;
}
          Var i: integer;
          Begin
          If cien = 1 Then
             Begin
             {okno cienia przesuniete o 2 w prawo i 1 w dol}
             Window (x1+2, y1+1, x2+2, y2+1);
             TextBackGround (0);
             TextColor(8);
             ClrScr;
             {znaki cienia na calym obszarze cienia}
             For i:=1 to ((x2-x1+1)*(y2-y1+1))-1 do Write ('');
             {plus dodatkowy znaczek cienia w prawym dolnym rogu}
             Window (x2+2, y2+1, x2+3, y2+1);
             Write ('');
             End;
          Window (x1, y1, x2, y2);
          TextBackGround (kolor_tla);
          ClrScr;
          {zmiana def. okna zeby mozna bylo pisac na Maxa z prawej}
          Window (x1, y1, x2+1, y2);
          TextColor(kolor_napisu);
          {kreslenie gornej poziomej ramki}
          If styl = 1 Then Write ('')
             Else Write ('');
          For i:=x1 to x2-2 do
              If styl = 1 Then Write ('')
                 Else Write ('');
          If styl = 1 Then Write ('')
             Else Write ('');
          {tytul po serodku gornej gornej poziomej ramki}
          If Length(tytul) mod (2) = 0 Then
             GotoXY ((x2-x1) div (2) - (Length(Tytul) div (2)) + 2, 1)
             Else GotoXY ((x2-x1) div (2) - (Length(Tytul) div (2)) + 1, 1);
          Write (Tytul);
          {kreslenie ramek pionowych}
          For i:=1 to (y2-y1-1) do
              Begin
              GotoXY (1, i+1);
              If styl = 1 Then Write ('')
                 Else Write ('');
              GotoXY (x2-x1+1, i+1);
              If styl = 1 Then Write ('')
                 Else Write ('');
              End;
          {kreslenie dolnej poziomej ramki}
          GotoXY (1, y2-y1+1);
          If styl = 1 Then Write ('')
             Else Write ('');
          For i:=x1 to x2-2 do
              If styl = 1 Then Write ('')
                 Else Write ('');
          If styl = 1 Then Write ('')
             Else Write ('');
          End;


Procedure Szare_tlo;
{   Generuje szare tlo na calym obszarze ponizej paska menu,
    a zarazem powyzej paska stanu.
}
          Var i: Word;
          Begin
          Window (1,2,80,25);
          TextBackGround (7);
          TextColor(1);
          ClrScr;
          For i:=1 to 1841 do   {bo 80*23=1840}
              Write ('');
          End;

Procedure Szare_tlo_czesc (x1, y1, x2, y2: Byte);
{   Generuje szare tlo na wybranym obszarze.
    Poniewaz procedura ta sluzy do usuwania wczesniej wyrysowanych
    okien, wybrany obszar jest poszezany o rozmiar cienia.
}
          var i: Word;
          Begin
          Window (x1, y1, x2+2, y2+1);
          TextBackGround (7);
          TextColor(1);
          ClrScr;
          {dodanie znaku tla na calym obszarze bylego okna minus 1}
             For i:=1 To ((x2+3)-x1)*((y2+2)-y1)-1 Do
                      Write ('');
          {dopisanie ostatniego znaku tla}
          Window (x2+2, y2+1, x2+3, y2+1);
          Write ('');
          End;

Procedure Zero_tlo;
{   Czysci caly ekran. Tlo czarne, pismo biale.
}
          Begin
          Window(1,1,80,25);
          TextBackGround(0);
          TextColor(7);
          ClrScr;
          End;


Procedure Sukaj_pliku (var nazwa: String; var jest: Byte );
{   Sprawdza czy dany plik slownika juz istnieje.
    Gdy plik juz istnieje parametr <jest> przybiera wartosc 1.
}
          Var Sciezka_pliku: PathStr;
          Begin
          Sciezka_pliku:= FSearch (nazwa+'.dik','') ;
          If Sciezka_pliku = '' Then
             Jest:= 0  Else Jest:= 1;
          End;


End.